aboutsummaryrefslogtreecommitdiffstatshomepage
diff options
context:
space:
mode:
authorLenz Weber <mail@lenzw.de>2015-01-28 17:36:13 +0100
committerJason A. Donenfeld <Jason@zx2c4.com>2015-01-28 17:40:25 +0100
commitf07291ba3ba1ac5bfb22474faadfd702db088af2 (patch)
tree8be9f6fe08d8e9b7720d892d0f63afff8efb7437
parentSkip broken tests. (diff)
downloadpassword-store-f07291ba3ba1ac5bfb22474faadfd702db088af2.tar.xz
password-store-f07291ba3ba1ac5bfb22474faadfd702db088af2.zip
cygwin + gpg4win: convert paths to windows paths when calling gpg4win binary instead of cygwin's gpg binary
-rwxr-xr-xsrc/password-store.sh2
-rw-r--r--src/platform/cygwin.sh25
2 files changed, 26 insertions, 1 deletions
diff --git a/src/password-store.sh b/src/password-store.sh
index afdaf39..c9a8f29 100755
--- a/src/password-store.sh
+++ b/src/password-store.sh
@@ -310,7 +310,7 @@ cmd_show() {
check_sneaky_paths "$path"
if [[ -f $passfile ]]; then
if [[ $clip -eq 0 ]]; then
- exec $GPG -d "${GPG_OPTS[@]}" "$passfile"
+ $GPG -d "${GPG_OPTS[@]}" "$passfile" || exit $?
else
local pass="$($GPG -d "${GPG_OPTS[@]}" "$passfile" | head -n 1)"
[[ -n $pass ]] || exit 1
diff --git a/src/platform/cygwin.sh b/src/platform/cygwin.sh
index 05c51e0..e0a90c7 100644
--- a/src/platform/cygwin.sh
+++ b/src/platform/cygwin.sh
@@ -14,3 +14,28 @@ clip() {
) 2>/dev/null & disown
echo "Copied $2 to clipboard. Will clear in $CLIP_TIME seconds."
}
+
+# replaces Cygwin-style filenames with their Windows counterparts
+gpg_winpath() {
+ local args=("$@")
+ # as soon as an argument (from back to front) is no file, it can only be a filename argument if it is preceeded by '-o'
+ local could_be_filenames="true"
+ local i
+ for ((i=${#args[@]}-1; i>=0; i--)); do
+ if ( [ $i -gt 0 ] && [ "${args[$i-1]}" = "-o" ] ); then
+ args[$i]=$(cygpath -am ${args[$i]})
+ elif [ $could_be_filenames = "true" ]; then
+ if [ -e ${args[$i]} ]; then
+ args[$i]=$(cygpath -am ${args[$i]})
+ else
+ could_be_filenames="false"
+ fi
+ fi
+ done
+ $GPG_ORIG "${args[@]}"
+}
+
+if $GPG --help | grep -q Gpg4win; then
+ GPG_ORIG="$GPG"
+ GPG=gpg_winpath
+fi